import controlP5.*;
ControlP5 controlP5;

import java.awt.datatransfer.*;
import java.awt.Toolkit; 

ClipHelper cp = new ClipHelper();

float[] coordsX;
float[] coordsY;
int length;

PFont font;

int pointDragged;

boolean showCode;

boolean fillState = true;

boolean dataState = true;

boolean curvesState = false;

void setup()
{
  size(800, 800);
  frameRate(25);
  font = loadFont("Silkscreen-9.vlw");
  textFont(font, 9);
  coordsX = new float[35];
  coordsY = new float[35]; 
  randomize(0);
  smooth();
  noFill();

  dataState = true;
  showCode = false;

  controlP5 = new ControlP5(this);
  controlP5.addButton("randomize", 0, 20, 15, 50, 19);
  controlP5.addButton("add", 0, 80, 15, 50, 19);
  controlP5.addButton("remove", 0, 140, 15, 50, 19);
  controlP5.Toggle t = controlP5.addToggle("fill", true, 200, 15, 19, 19);//.setMode(ControlP5.SWITCH);
  t.setColorLabel(0);
  t = controlP5.addToggle("data", true, 230, 15, 19, 19);//.setMode(ControlP5.SWITCH);
  t.setColorLabel(0);
  t = controlP5.addToggle("curves", curvesState, 260, 15, 19, 19);//.setMode(ControlP5.SWITCH);
  t.setColorLabel(0);
  controlP5.addButton("copy", 0, 290, 15, 50, 19);
}


void draw() {
  background(255);

  if ( showCode ) {
    fill(0);
    int j = 10;
    text("beginShape();", 10, j);
    for ( int i =0; i < length; i++ ) {
      j = j + 10;
      text("curveVertex( "+coordsX[i]+" , "+coordsY[i]+" );", 10, j);
    }
    text("endShape();", 10, j+10);
  } 
  else {



    if ( dataState && curvesState ) {
      noFill();
      stroke(200,100,100);
      beginShape();
      if ( curvesState) {
        curveVertex(coordsX[0], coordsY[0]);
        curveVertex(coordsX[0], coordsY[0]);
      } 
      else {
        vertex(coordsX[0], coordsY[0]);
        vertex(coordsX[0], coordsY[0]);
      }


      for ( int i =1; i < length-1 ; i++) {
        if ( curvesState) curveVertex(coordsX[i], coordsY[i]);
        else vertex(coordsX[i], coordsY[i]);
      }

      if ( curvesState) {
        curveVertex(coordsX[length-1], coordsY[length-1]);
        curveVertex(coordsX[length-1], coordsY[length-1]);
      } 
      else {
        vertex(coordsX[length-1], coordsY[length-1]);
        vertex(coordsX[length-1], coordsY[length-1]);
      }
      endShape();
      stroke(0);
      ellipse(coordsX[0], coordsY[0], 3, 3);
    }


    stroke(0);
    if ( fillState) fill(127);
    else noFill();
    beginShape();

    for ( int i =0; i < length ; i++) {
      if ( curvesState) curveVertex(coordsX[i], coordsY[i]);
       else vertex(coordsX[i], coordsY[i]);
    }
    endShape();

    if ( dataState ) {
      for ( int i =0; i < length ; i++) {
        fill(0);
        stroke(0);
        text(int(coordsX[i])+" , "+int(coordsY[i]), coordsX[i]+5, coordsY[i]+5);
        noFill();
        ellipse(coordsX[i], coordsY[i], 3, 3);
      }
    }
    /*
    if ( data ) {
     stroke(200);
     beginShape();
     
     endShape();
     }
     */
  }
}

void mousePressed() {

  // Find closest point
  float closestDistance = 40; // minimal distance
  int closestPoint = -1;
  for ( int i=0; i < length;i++ ) {
    float distance = dist(mouseX, mouseY, coordsX[i], coordsY[i]);
    if ( distance < closestDistance) {
      closestPoint = i;
      closestDistance = distance;
    }
  }

  pointDragged = closestPoint;
}

void mouseDragged() {
  if ( pointDragged != -1 ) {
    // Update last curveVertex
    coordsX[pointDragged] = mouseX;
    coordsY[pointDragged] = mouseY;
  } 
  else {
    for ( int i =0; i < length ; i++) {
      coordsX[i] = coordsX[i] + mouseX - pmouseX;
      coordsY[i] = coordsY[i] + mouseY - pmouseY;
    }
  }
}

void mouseReleased() {
  pointDragged = -1;
}

/*
void keyPressed() {
 if ( key == ' ' ) {
 if ( length < coordsX.length) { 
 coordsX[length] = mouseX-200;
 coordsY[length] = mouseY-200;
 length = length + 1;
 }
 } 
 else if ( key == '\b' ) {
 if ( length > 4) length = length - 1;
 } 
 else if ( key == 'h' ) {
 data = !data;
 }
 else if ( key == 'c' ) {
 showCode = !showCode;
 }
 }
 */


public void add(int theValue) {
  if ( length < coordsX.length) { 
    float angle = atan2(coordsY[length-1]-coordsY[length-2], coordsX[length-1]-coordsX[length-2]);
    /*
      coordsX[length] = (int)random(40)-20 + coordsX[length-1];
     coordsY[length] = (int)random(40)-20 + coordsY[length-1];
     */
    coordsX[length] = cos(angle) * 40 + coordsX[length-1];
    coordsY[length] = sin(angle) * 40 + coordsY[length-1];
    length = length + 1;
  }
}


public void remove(int theValue) {
  if ( length > 4) length = length - 1;
}

public void randomize(int theValue) {
  for ( int i=0; i < coordsX.length; i++ ) {
    coordsX[i] = (int)random(height-10)+5;
    coordsY[i] = (int)random(width-10)+5;
  }
  length = int(random(5)+4);
} 

public void fill(boolean theValue) {
  fillState = theValue;
} 

public void curves(boolean theValue) {
  curvesState = theValue;
} 

public void data(boolean theValue) {
  dataState = theValue;
} 

public void copy(int theValue) {
  String code = new String();
  code = code + "beginShape();\r";
  for ( int i =0; i < length ; i++) {
      if ( curvesState) code = code + "curveVertex("+coordsX[i]+", "+coordsY[i]+");\r";
       else code = code + "vertex("+coordsX[i]+", "+coordsY[i]+");\r";
    }
  code = code + "endShape();\r";  
  cp.copyString(code);
}